SystemOrganization addCategory: #LandSlide!

Object subclass: #DocumentationHolder
	instanceVariableNames: 'classes methods decls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!DocumentationHolder class methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 16:47'!
withClasses: classes andMethods: methods
	^ (self new classes: classes) methods: methods! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 16:47'!
classes: theClasses
	classes := theClasses! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 17:09'!
decls: theDecls
	decls := theDecls! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 16:47'!
methods: theMethods
	methods := theMethods! !

Object subclass: #LandSlideParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 14:28'!
parseString: aString 
	| cffp parser declarations methods classes |
	"Parses a given file written in ChunkFileFormat, returning an object
	which represents the materials necessary for generating documentation"
	cffp := ChunkFileFormatParser for: (ReadStream on: aString).
	parser := Parser new.
	declarations := cffp parseDeclarations.
	methods := 
		declarations 
			select: [ :decl | decl isKindOf: MethodDeclaration ]
			thenCollect: [ :decl | parser parse: (decl contents) class: UndefinedObject  ].
	^ (DocumentationHolder withClasses: (OrderedCollection new) andMethods: methods) decls: declarations.! !

Object subclass: #MonticelloUnpacker
	instanceVariableNames: 'filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!MonticelloUnpacker class methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:44'!
fromUrl: url
	"Passing a string url to a monticello project online this will download that 
	file and get the contents of the snapshot.st file and also will cleanup after 
	itself with all temporary files"
	| dir znurl filename unpacker stringContents |
	dir := FileSystem disk workingDirectory .
	ZnClient new
		url: url;
		downloadTo:dir . 
	znurl := ZnUrl fromString: url .
	filename := znurl lastPathSegment .
	unpacker := (MonticelloUnpacker new)
		filename: (dir / filename) .
	stringContents := unpacker extractStringFromFile .
	unpacker cleanupFile .
	^stringContents! !

!MonticelloUnpacker class methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:43'!
getNewFileContents
	"This will open a filepicker where the user can select a .mcz file and our unpacker
	will take that file and get the contents of the snapshot.st file and also will cleanup after 
	itself with all temporary files"
	| file unpacker |
	file := StandardWindow new fileOpen: '' .
	unpacker := (MonticelloUnpacker new)  
		filename: file .
	^ unpacker extractStringFromFile ! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:33'!
cleanupFile
	self filename deleteAll! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:42'!
extractStringFromFile
	"This will actually take the filename used for this unpacker and extract it 
	and return the contents of snapshot.st"
	| fulldir dir zip fileStream fileContents|
	fulldir := self filename .
	zip := ZipArchive new readFrom: (fulldir fullName) .
	dir := FileSystem disk workingDirectory / 'temp'.
	dir createDirectory .
	zip extractAllTo:  dir .
	fileStream := (dir / 'snapshot' / 'source.st') readStream .
	fileContents := fileStream contents .
	dir deleteAll .
	^fileContents! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:20'!
filename
	"comment stating purpose of message"
	^ filename! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:20'!
filename: aFileName
	"comment stating purpose of message"
	filename := aFileName! !

TestCase subclass: #LandSlideTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!
